$(document).ready(function () {
    $("body").on("blur", ".hsncode", itemModalShow);
    $(".iTbody").on("click", ".itemTr", addTrVal);
    $(".itemModal").on("keyup", ".isearch", getItemData);
    $(".itemModal").on("change", ".isortBy, iorderAS", getItemData);
    $(".inoRecord").hide();

    window.addEventListener('keydown', function (e) {
        if (e.keyIdentifier == 'U+000A' || e.keyIdentifier == 'Enter' || e.keyCode == 13) {
            if (e.target.nodeName == 'INPUT' && e.target.type == 'text' && e.target.className == "iname") {
                addTrVal(e);
            }
        }
    }, true);

    function itemModalShow() {
        var tr = $(this).closest("tr"),
                srno = tr.find(".srno").val(),
                party = $(".cmbparty").val(),
                file = $(".file").val(),
                margin = srno * 2.5,
                hsncode = tr.find(".hsncode").val(),
                itemcode = tr.find(".itemcode").val();
        $(".modal-content").css("margin-top", margin + "%")

        if (hsncode == "") {
            $(".ms").removeClass("datams");
            $(".hsncode").removeClass("datahsncode");
            $(".descrip1").removeClass("dataDescrip1");
            $(".descrip2").removeClass("dataDescrip2");
            

            $(".ms").addClass("datams");
            tr.find(".hsncode").addClass("datahsncode");
            tr.find(".descrip1").addClass("dataDescrip1");
            tr.find(".descrip2").addClass("dataDescrip2");
            $(".itemModal").modal("show");
            getItemData();
        } else {
//            $.ajax({
//                type: "POST",
//                datatype: "json",
//                url: "search_ibarcode.php",
//                data: {barcode: hsncode, itemcode: itemcode,party: party,file:file},
//                success: function (response) {
//                    var m = response;
//
//                    tr.find(".itemname").val(m.name);
//                    tr.find(".barcode").val(m.barcode);
//                    tr.find(".itemcode").val(m.itemcode);
//                    tr.find(".gram").val(m.gram);
//                    tr.find(".unit").val(m.unit);
//                    tr.find(".hsncode").val(m.hsncode);
//                    tr.find(".mrp").val(m.mrp);
//                    tr.find(".gstperc").val(m.gstperc);
//                    tr.find(".cartqty").val(m.cartqty);
////                    debugger
//                    var rate = tr.find(".rate").val();
//                    if (rate != 0) {
//                        tr.find(".rate").val(rate);
//                    } else {
//                        tr.find(".rate").val(m.rate);
//                    }
//
//                    tr.find(".qty").focus();
//                    tr.find(".qty").select();
//
//                },
//                error: function (request, textStatus, errorThrown) {
//
//                }
//            });
        }
    }

    $(".itemModal").on('shown.bs.modal', function () {
        $(".isearch").focus();
        $(".isearch").val("");
        $(".ifield").val("1");
        getItemData();
    });

    $(".itemModal").on('hidden.bs.modal', function () {
        $(".dataQty").focus();
//        $(".qty").focus();
        $(".dataQty").select();
    });

    var imrangeFrom = 0,
            imrangeTo = 40;

    function getItemData(pagination) {

        $(".iloader").show();

        if (pagination == 'prev') {
            if (imrangeFrom > 0) {
                imrangeFrom = (imrangeFrom - 40);
                imrangeTo = (imrangeTo - 40);
            }
        }
        if (pagination == 'next') {
            imrangeFrom = (imrangeFrom + 40);
            imrangeTo = (imrangeTo + 40);
        }

        var vouchno = $(".vouchno").val(),
                file = $(".file").val(),
                isearch = $(".isearch").val(),
                ifield = $(".ifield").val(),
                ioperator = $(".ioperator").val(),
                sortBy = $(".isortBy").val(),
                orderAs = $(".iorderBy").val(),
                party = $(".cmbparty").val(),
                datams = $(".datams").val(),
                data = {isearch: isearch, ifield: ifield, ioperator: ioperator, sortBy: sortBy, orderAs: orderAs,datams:datams,
                    vouchno: vouchno, file: file, rangeFrom: imrangeFrom, rangeTo: imrangeTo, party: party},
        values = "";
        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "search_item.php",
            data: data,
            success: function (response) {
                $.each(response, function () {
                    values += "<tr class='itemTr'>" +
//                            "<td align='left'><input type='text' class='itemcode' value='" + this.itemcode + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='ihsncode' value='" + this.hsncode + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='idescrip1' value='" + this.descrip1 + "' readonly style='width:100%'></td>" +
                            "<td align='left'><input type='text' class='idescrip2' value='" + this.descrip2 + "' readonly style='width:100%'></td>" +
//                            "<td align='left'><input type='text' class='igram' value='" + this.gram + "' readonly style='width:100%'tabindex='-1'></td>" +
//                            "<td align='left'><input type='text' class='iunit' value='" + this.unit + "' readonly style='width:100%'tabindex='-1'>\n\
//                             <input type='hidden' class='ihsncode' value='" + this.hsncode + "'  style='width:100%'tabindex='-1'>\n\
//                             <input type='hidden' class='imrp' value='" + this.mrp + "'  style='width:100%'tabindex='-1'>\n\
//                             <input type='hidden' class='igstperc' value='" + this.gstperc + "' readonly style='width:100%'tabindex='-1'></td>" +
//                            "<td align='left'><input type='text' class='irate' value='" + this.rate + "' readonly style='width:100%'tabindex='-1'>\n\
//                                             <input type='hidden' class='icartqty' value='" + this.cartqty + "'  style='width:100%'tabindex='-1'>\n\</td>" +
                            "</tr>";
                });
                $(".iloader").hide();
                $(".iTbody").empty();
                $(".iTbody").html(values);
                if (response) {
                    $(".search-action-bar").show();
                }
            },
            error: function (request, textStatus, errorThrown) {

            }
        });
    }
    $(".iload").click(function () {
        getItemData();
    });
//    $(".isearch").change(function () {
//        getItemData();
//    });
    $(".iprevious").click(function () {
        getItemData('prev');
    });
    $(".inext").click(function () {
        getItemData('next');
    });

    function addTrVal(e) {
        var tr = "";
        if (e == "undefined") {
            tr = $(this).closest("tr");
        } else {
            tr = $(e.target).closest("tr");
        }

        var ihsncode = tr.find(".ihsncode").val(),
                idescrip1 = tr.find(".idescrip1").val(),
                idescrip2 = tr.find(".idescrip2").val();



        $(".datahsncode").val(ihsncode);
        $(".dataDescrip1").val(idescrip1);
        $(".dataDescrip2").val(idescrip2);
        
        $(".dataDescrip1").removeClass('dataDescrip1');
        $(".dataDescrip2").removeClass('dataDescrip2');
        $(".datahsncode").removeClass('datahsncode');
        
        $(".itemModal").modal("hide");
        $(".qty").focus();

    }

    $(".rate").focus(function () {
        $(".dataQty").removeClass("dataQty");
    });
});